<script setup lang="ts">
import { useBranchStore } from '@/stores/branch'
import { useLoadingStore } from '@/stores/loading'
import axios from 'axios'
import { computed, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import MapView from './MapView.vue'
import { useMapStore } from '../../stores/map'
const branchStore = useBranchStore()
const LoadingStore = useLoadingStore()
const mapStore = useMapStore()
onMounted(() => {
  branchStore.getBranches()
  mapStore.useIn = 'branchView'
})
const branches = computed(() => branchStore.branches)
const refForm = ref<VForm | null>(null)
</script>

<template>
  <div>
    <v-sheet>
      <v-container fluid>
        <v-toolbar flat>
          <v-toolbar-title>Branch Management</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="branchStore.dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                size="40px"
                v-bind="props"
                prepend-icon="mdi-plus-thick"
                class="mr-5"
                @click="mapStore.branchAddress = null"
              >
                <!-- New User -->
              </v-btn>
            </template>
            <v-card style="background-color: #fff5e8">
              <v-card-title>
                <span class="text-h5">New Branch</span>
              </v-card-title>
              <v-card-text>
                <v-form
                  ref="refForm"
                  v-model="branchStore.from"
                  @submit.prevent="branchStore.onSubmit"
                >
                  <v-container>
                    <v-row>
                      <v-col cols="12" md="4" sm="6">
                        <v-text-field
                          v-model="branchStore.editedBranch.name"
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" md="4" sm="6">
                        <v-text-field
                          v-model="branchStore.editedBranch.address"
                          label="Address no. street village subdistrict"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" md="4" sm="6">
                        <v-text-field
                          v-model="branchStore.editedBranch.city"
                          label="District"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" md="4" sm="6">
                        <v-text-field
                          v-model="branchStore.editedBranch.province"
                          label="Province"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" md="4" sm="6">
                        <v-text-field
                          v-model="branchStore.editedBranch.postalcode"
                          label="Postal Code"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" md="4" sm="6">
                        <v-text-field
                          v-model="branchStore.editedBranch.latitude"
                          label="Latitude"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" md="4" sm="6">
                        <v-text-field
                          v-model="branchStore.editedBranch.longitude"
                          label="Longitude"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12">
                        <v-card>
                          <v-card-title class="text-h5 d-flex justify-center pa-10"
                            >Map</v-card-title
                          >
                          <v-row justify="center">
                            <map-view></map-view>
                          </v-row>
                          <v-row justify="center" style="padding-top: 10px; padding-bottom: 10px">
                            <v-btn
                              @Click="
                                () => {
                                  branchStore.editedBranch.latitude = mapStore.lat
                                  branchStore.editedBranch.longitude = mapStore.lng
                                }
                              "
                            >
                              get Lat and Lng
                            </v-btn>
                          </v-row>
                        </v-card>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn variant="text" @click="branchStore.save()"> Save </v-btn>
                <v-btn variant="text" @click="branchStore.closeDialog()"> Close </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-dialog v-model="branchStore.dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn variant="text" @click="branchStore.closeDelete()">Cancel</v-btn>
                <v-btn variant="text" @click="branchStore.deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>

        <v-table fixed-header height="530">
          <thead>
            <tr>
              <th>Id</th>
              <th>Name</th>
              <th>Address</th>
              <th>City</th>
              <th>Province</th>
              <th>Country</th>
              <th>Postalcode</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="item in branchStore.branches" :key="item.id">
              <td>{{ item.id }}</td>
              <td>{{ item.name }}</td>
              <td>{{ item.address }}</td>
              <td>{{ item.city }}</td>
              <td>{{ item.province }}</td>
              <td>{{ item.country }}</td>
              <td>{{ item.postalcode }}</td>
              <td>
                <v-icon size="small" class="me-2" @click="branchStore.editItem(item)">
                  mdi-pencil
                </v-icon>
                <v-icon size="small" @click="branchStore.deleteItem(item)"> mdi-delete </v-icon>
              </td>
            </tr>
          </tbody>

          <template v-if="!branches.length">
            <v-btn @click="branchStore.getBranches()"> Reset </v-btn>
          </template>
        </v-table>
      </v-container>
    </v-sheet>
  </div>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}
</style>
